.model small,c
.386
.stack

include support.asm

;------------------------------------------------------
; Declare a structure for the DOS Memory Control Block.
; In the Microsoft references this structure is named
; ARENA.
;------------------------------------------------------

MCB STRUC
  mcbSignature db ?         ; "M" = valid, "Z" = last
  mcbOwner     dw ?         ; PSP segment of owner
  mcbSize      dw ?         ; size of block in paragraphs
  mcbReserved  db 3 dup(?)
  mcbName      db 8 dup(?)  ; null-terminated owner filename
MCB ENDS

.data
.code
.startup

    mov ah, 62h
    int 21h
    print "Our PSP seg = ",hexword$(bx),"h",NL,NL

    print "Press any key to continue...",NL
    call waitkey

    print "Allocating 16-byte block",NL
    mov ah, 48h
    mov bx, 1
    int 21h
    print "seg address of block = ",hexword$(ax),"h",NL
    sub ax, 1
    mov es, ax
    xor bx, bx
    print "mcb signature = '"
    putch es:[bx].MCB.mcbSignature
    print "'",NL
    print "PSP seg of owner = ",hexword$(es:[bx].MCB.mcbOwner),"h",NL
    print "block size = ",hexword$(es:[bx].MCB.mcbSize),"h",NL,NL
    ;---------------------------------------
    ; The owner filename appears to be junk.
    ;---------------------------------------
    ;print "owner filename = '"
    ;OF = 0
    ;REPEAT 8
    ;  putch es:[bx].MCB.mcbName + OF
    ;  OF = OF + 1
    ;ENDM
    ;print "'",NL

    print "Allocating 0-byte block",NL
    mov ah, 48h
    xor bx, bx
    int 21h
    jnc @F
    print "error ",hexword$(ax),"h",NL
  @@:
    print "seg address of block = ",hexword$(ax),"h",NL
    sub ax, 1
    mov es, ax
    xor bx, bx
    print "mcb signature = '"
    putch es:[bx].MCB.mcbSignature
    print "'",NL
    print "PSP seg of owner = ",hexword$(es:[bx].MCB.mcbOwner),"h",NL
    print "block size = ",hexword$(es:[bx].MCB.mcbSize),"h",NL,NL

    print "Allocating 0-byte block",NL
    mov ah, 48h
    xor bx, bx
    int 21h
    jnc @F
    print "error ",hexword$(ax),"h",NL
  @@:
    print "seg address of block = ",hexword$(ax),"h",NL
    sub ax, 1
    mov es, ax
    xor bx, bx
    print "mcb signature = '"
    putch es:[bx].MCB.mcbSignature
    print "'",NL
    print "PSP seg of owner = ",hexword$(es:[bx].MCB.mcbOwner),"h",NL
    print "block size = ",hexword$(es:[bx].MCB.mcbSize),"h",NL,NL

    print "Allocating 16-byte block",NL
    mov ah, 48h
    mov bx, 1
    int 21h
    print "seg address of block = ",hexword$(ax),"h",NL
    sub ax, 1
    mov es, ax
    xor bx, bx
    print "mcb signature = '"
    putch es:[bx].MCB.mcbSignature
    print "'",NL
    print "PSP seg of owner = ",hexword$(es:[bx].MCB.mcbOwner),"h",NL
    print "block size = ",hexword$(es:[bx].MCB.mcbSize),"h",NL

    call waitkey
.exit
end